 package com.imanan.LiveCamera;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

public class MenuActivity extends Activity {
    //ݒ
    private static final int REQUEST_CODE_PREFERENCES = 1;
    private static final int REQUEST_CODE_GPS = 2;
    private static final int REQUEST_CODE_NOWMAP  = 3;
    private String infoUserid = "";
    private String infoName;
    private String infoAddr1;
    private String infoAddr2;
    private String infoTel;
    private String infoIndustry;
    private String infoPass;
    private String infoGps = "";


//	private Intent intent_info = new Intent(MenuActivity.this, LiveCamera2Activity.class);
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);


        // ݒl̎擾
        final SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
        infoName     = pref.getString("infoName", "");
        infoAddr1    = pref.getString("infoAddr1", "");
        infoAddr2    = pref.getString("infoAddr2", "");
      	infoIndustry = pref.getString("infoAddr2", "");
        infoPass     = pref.getString("infoPass", "");
        infoUserid   = pref.getString("infoUserid", "");
        infoGps      = pref.getString("infoGps", "");

        if ( infoUserid == "" ) {
            startActivityForResult(new Intent(this, Preference.class),REQUEST_CODE_PREFERENCES);
            
//          infoUserid = doPostId("http://oup.imanan.com/och_ent.php",null );
//          if ( infoUserid != "" ) {
//            pref.edit().putString("infoUserid", infoUserid).commit();
//          }
        }
        
        Log.d("infoUserid",pref.getString("infoUserid", ""));

    	setContentView(R.layout.menu);

        // Be{^̐ݒ
        Button button_shut = (Button) findViewById(R.id.button_shut);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_shut.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("MenuActivity","onClick Shut");
            	Intent intent_shut = new Intent(MenuActivity.this, LiveCameraActivity.class);
            	startActivityForResult(intent_shut,REQUEST_CODE_PREFERENCES);
            }
        });
        // ݒ{^̐ݒ
        Button button_set = (Button) findViewById(R.id.button_set);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_set.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("MenuActivity","onClick Set");
                Intent intent_set = new Intent(MenuActivity.this, Preference.class);
            	startActivityForResult(intent_set,REQUEST_CODE_PREFERENCES);
            }
        });
        // \iWEBj{^̐ݒ
        Button button_info = (Button) findViewById(R.id.button_info);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_info.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("MenuActivity","onClick Info");
            	Uri uri;
            	if ( infoUserid != null ) {
                  String[] infoUseridValArr = infoUserid.split("@");  // userid@serverid
                  uri = Uri.parse("http://live.imanan.com/info.php?userno=" + infoUseridValArr[0]);
            	} else {
                  uri = Uri.parse("http://live.imanan.com/info.php?userno=");            		
            	}
                Intent i = new Intent(Intent.ACTION_VIEW,uri);
                startActivity(i);
            }
        });
/*
        // \in}j{^̐ݒ
        Button button_map = (Button) findViewById(R.id.button_map);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_map.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("MenuActivity","onClick Map");
            	Intent intent_map = new Intent(MenuActivity.this, LiveMapActivity.class);
            	startActivityForResult(intent_map,REQUEST_CODE_PREFERENCES);
            }
        });
*/
        // GPS{^̐ݒ
        Button button_gps = (Button) findViewById(R.id.button_gps);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_gps.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("GpsActivity","onClick Gps");            	
            	Intent intent_gps = new Intent(MenuActivity.this, GpsActivity.class);
            	startActivityForResult(intent_gps,REQUEST_CODE_GPS);

            }
        });

        // \i}bv ݒnj{^̐ݒ
        Button button_nowmap = (Button) findViewById(R.id.button_mapnow);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_nowmap.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("GpsActivity","onClick mapnow");            	
            	Intent intent_gps = new Intent(MenuActivity.this, GpsActivity.class);
            	startActivityForResult(intent_gps,REQUEST_CODE_NOWMAP);
            }
        });
        // \i}bv o^nj{^̐ݒ
        Button button_livemap = (Button) findViewById(R.id.button_maplive);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_livemap.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("MenuActivity","onClick maplive");
            	Uri uri;
            	infoGps = pref.getString("infoGps", "");
                try {
                  String[] infoGpsValArr = infoGps.split(",");  // latitude,longitude
                  uri = Uri.parse("http://live.imanan.com/search.php?latitude=" + infoGpsValArr[0] + "&longitude=" + infoGpsValArr[1] + "&zoom=19" );
                  Intent i = new Intent(Intent.ACTION_VIEW,uri);
                  startActivity(i);
                } catch (Exception e) {
                	errMessage("GPSݒ肳Ă܂BuݒiGPSFݒnݒjv{łB");  
//                uri = Uri.parse("http://live.imanan.com/search.php?latitude=&longitude=");
            	}
            }
        });
        // wv{^̐ݒ
        Button button_help = (Button) findViewById(R.id.button_help);
        // {^NbNꂽɌĂяoR[obNXi[o^܂
        button_help.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // {^NbNꂽɌĂяo܂
            	Log.d("MenuActivity","onClick Help");
                Uri uri = Uri.parse("http://live.imanan.com/android.php");            		
                Intent i = new Intent(Intent.ACTION_VIEW,uri);
                startActivity(i);
            }
        });
	}
	public void errMessage(String message)
	{
		Toast.makeText(this, message, Toast.LENGTH_SHORT).show(); 
	}
    public String doPostId( String url,List<NameValuePair> params )
    {
      Log.d("doPostId","start");

      try {            
    	  DefaultHttpClient client = new DefaultHttpClient();
        //@͐œKPHPŏĂ
Log.d("doPostId","url:"+url);
        HttpPost post = new HttpPost(url);
        MultipartEntity entity = new MultipartEntity();
        post.setEntity(entity);
        
        //------------------------
     // POST Request\zB
/*
        List<NameValuePair> params = new ArrayList<NameValuePair>();
        params.add(new BasicNameValuePair("userId", "user-id"));
        params.add(new BasicNameValuePair("password", "password"));
*/
        if ( params != null ) {
        	post.setEntity(new UrlEncodedFormEntity(params));
        }
        //------------------------

        Log.d("doPostId","exec");

        //M
        HttpResponse response = client.execute( post );
        Log.d("doPostId","response");
        int status = response.getStatusLine().getStatusCode();
        if ( status != HttpStatus.SC_OK )
          throw new Exception( "" );
          Log.d("doPostId","end");
        return EntityUtils.toString( response.getEntity(), "UTF-8" ).replaceAll("\r\n", "\n").replaceAll("[\n|\r]", "");
      }
      catch ( Exception e ) {
        Log.d("doPostId","Error");
        return null;
      }
    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        Log.d("onActivityResult","Start");
        int doPostFlg = 0;
    	SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);   

        if (requestCode == REQUEST_CODE_PREFERENCES) {
            if ( infoName != pref.getString("infoName", "")) {
              infoName   = pref.getString("infoName", ""); doPostFlg = 1;
            }
            if ( infoAddr1 != pref.getString("infoAddr1", "")) {
              infoAddr1   = pref.getString("infoAddr1", ""); doPostFlg = 1;
            }
            if ( infoAddr2 != pref.getString("infoAddr2", "")) {
              infoAddr2   = pref.getString("infoAddr2", ""); doPostFlg = 1;
            }
            if ( infoTel != pref.getString("infoTel", "")) {
              infoTel   = pref.getString("infoTel", ""); doPostFlg = 1;
            }
            if ( infoIndustry != pref.getString("infoIndustry", "")) {
          	  infoIndustry = pref.getString("infoIndustry", ""); doPostFlg = 1;
            }
            if ( infoPass != pref.getString("infoPass", "")) {
              infoPass   = pref.getString("infoPass", ""); doPostFlg = 1;
            }
    		infoUserid = pref.getString("infoUserid", "");
            if ( infoUserid == "" ) {
            	doPostFlg = 1;
            }
            infoGps = pref.getString("infoGps", "");

//    		String utext = new String(stext.getBytes("ISO8859_1"), "Shift-JIS");
/*
            String uinfoName = infoName;
            String uinfoAddr2 = infoAddr2;
			try {
				uinfoName = new String(infoName.getBytes("ISO8859_1"), "Shift-JIS");
				uinfoAddr2 = new String(infoAddr2.getBytes("ISO8859_1"), "Shift-JIS");
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
*/
        } else if (requestCode == REQUEST_CODE_GPS) {
            infoName   = pref.getString("infoName", ""); doPostFlg = 1;
            infoAddr1   = pref.getString("infoAddr1", ""); doPostFlg = 1;
            infoAddr2   = pref.getString("infoAddr2", ""); doPostFlg = 1;
            infoTel   = pref.getString("infoTel", ""); doPostFlg = 1;
        	infoIndustry = pref.getString("infoIndustry", ""); doPostFlg = 1;
            infoPass   = pref.getString("infoPass", ""); doPostFlg = 1;
            infoUserid = pref.getString("infoUserid", "");
        	infoGps = (String) data.getCharSequenceExtra("GPS");
        	doPostFlg = 1;
/*          
        	String get_infoGps = (String) data.getCharSequenceExtra("GPS");
            if ( infoGps != get_infoGps) {
                infoGps   = get_infoGps;
            }
*/
            if ( infoGps != "" ) {
          	  pref.edit().putString("infoGps", infoGps).commit();
          	  Toast.makeText(this, "GPSXVF"+infoGps, Toast.LENGTH_SHORT).show();  
            } else {
                Toast.makeText(this, "GPSXVł܂łB", Toast.LENGTH_SHORT).show();                
            }
        } else if (requestCode == REQUEST_CODE_NOWMAP) {
        	Uri uri;
        	String NowGps = (String) data.getCharSequenceExtra("GPS");
        	try {
              String[] NowGpsValArr = NowGps.split(",");  // latitude,longitude
              uri = Uri.parse("http://live.imanan.com/search.php?latitude=" + NowGpsValArr[0] + "&longitude=" + NowGpsValArr[1] + "&zoom=19");
              Intent i = new Intent(Intent.ACTION_VIEW,uri);
              startActivity(i);
			} catch (Exception e) {
              Log.d("onActivityResult","NowMap not NowGPS");
//            uri = Uri.parse("http://live.imanan.com/search.php?latitude=&longitude=");
        	}
          	doPostFlg = 0;
	
        }
        if ( doPostFlg == 1 ) {
/*
            List<NameValuePair> params = new ArrayList<NameValuePair>();
            params.add(new BasicNameValuePair("oui", infoUserid));
//          params.add(new BasicNameValuePair("oun", uinfoName));
            params.add(new BasicNameValuePair("oua1", infoAddr1));
            params.add(new BasicNameValuePair("oua2", uinfoAddr2));
            params.add(new BasicNameValuePair("out", infoTel));
            params.add(new BasicNameValuePair("ousi", infoIndustry));
            params.add(new BasicNameValuePair("oup", infoPass));
            params.add(new BasicNameValuePair("oug", infoGps));
//          infoUserid = doPostId("http://oup.imanan.com/och_ent.php?oun="+uinfoName,params);
*/
//        	url = URLEncoder.encode(url , "UTF-8");
        	String enc_infoName = infoName;
        	String enc_infoAddr2 = infoAddr2;
        	String enc_infoTel= infoTel;
        	String enc_infoPass= infoPass;
			try {
	        	enc_infoName = URLEncoder.encode(infoName, "UTF-8");
				enc_infoAddr2 = URLEncoder.encode(infoAddr2, "UTF-8");
	        	enc_infoTel = URLEncoder.encode(infoTel, "UTF-8");
	        	enc_infoPass = URLEncoder.encode(infoPass, "UTF-8");
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        	
            infoUserid = doPostId("http://oup.imanan.com/och_ent.php"
            		+"?oui="+infoUserid
            		+"&oun="+enc_infoName
            		+"&oua1="+infoAddr1
            		+"&oua2="+enc_infoAddr2
            		+"&out="+enc_infoTel
            		+"&ousi="+infoIndustry
            		+"&oup="+enc_infoPass
            		+"&oug="+infoGps
            		,null);
Log.d("doPostId","infoUserid:"+infoUserid);
            if ( infoUserid != null ) {
                pref.edit().putString("infoUserid", infoUserid).commit();
            }
            doPostFlg = 0;
        }
    }
}
